<?php
// Autor (c) Miroslav Novak, www.platiti.cz
// Pouzivani bez souhlasu autora neni povoleno
// #Ver:PRV089-22-g45d1515b:2021-09-02#

defined('_JEXEC') or die('Restricted access');


if (!class_exists('vmPSPlugin')) {
	require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

if(!class_exists('VirtueMartCart')) {
	require(JPATH_VM_SITE.'/helpers/cart.php');
}

require_once(dirname(__FILE__)."/UniModul.php");   //JPATH_BASE nelze pouzit, protoze je jiny pro admin a jiny pro klienty

class plgVmPaymentUniAdapter extends vmPSPlugin {

	public $uniModul;   // stacil by asi private

	function __construct(& $subject, $config, $uniModulName = null, $subMethod = null) {
		try {
			BeginUniErr();
			parent::__construct($subject, $config);
			// 		vmdebug('Plugin stuff',$subject, $config);
			$this->_loggable   = true;

			// zkusit zrusit viz komentar k getVmPluginCreateTableSQL [TODO]
			$this->tableFields = array_keys($this->getTableSQLFields());

			$varsToPush = $this->getVarsToPush();
			$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);


			if (is_null($uniModulName)) return EndUniErr();

			BeginUniErr(E_UNIERR_DEFAULT & ~E_NOTICE); // kvuli varovani o VMLANGu
			$this->getPluginMethods ($this->getVendorId());
			EndUniErr();
			if (empty($this->methods)) {
				return EndUniErr();
			}

			$uniFact = new UniModulFactory();
			$this->configInfo = $uniFact->getConfigInfo($uniModulName, $this->getLanguage(), $subMethod);

			$configSetting = $this->getConfigData($this->configInfo, $uniModulName, $subMethod);
			$this->configSetting = $configSetting;

			$this->uniModul = $uniFact->createUniModul($uniModulName, $configSetting, $subMethod);
			EndUniErr();
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}

	protected function getVendorId() {
		$app = JFactory::getApplication();
		if ($app->isAdmin() || $app->getName() == 'administrator') {
			$vendorId = 1;
		} else {
			$cart = VirtueMartCart::getCart();
			$vendorId = $cart->vendorId;
		}
		return $vendorId;
	}

	protected function getConfigData($configInfo, $uniModulName, $subMethod) {
		if (!empty($this->configSetting)) return $this->configSetting;

		if ($subMethod!='') {  // nacteme parametry hlavniho binderu
			$bkname = $this->_name;
			$this->_name = strtolower($uniModulName.'binder');
			if (isset($this->_xmlFile)) {
				$bkxmlfile = $this->_xmlFile;
				$this->_xmlFile	= JPath::clean( VMPATH_ROOT .DS. 'plugins' .DS. $this->_type .DS.  $this->_name . DS. $this->_name . '.xml'); // bez toho se nacachuje struktura konfigurace hlavniho modulu podle xml submetody a chybi pak parametry
			}
			$varsToPush = $this->getVarsToPush ();
			$this->setConfigParameterable ($this->_configTableFieldName, $varsToPush);
			$bkmethods = $this->methods;
			$this->methods = null;
			$this->getPluginMethods ($this->getVendorId());
			$method = $this->methods[0];
			$this->methods = $bkmethods;
			$this->_name = $bkname;
			if (isset($this->_xmlFile)) {
				$this->_xmlFile = $bkxmlfile;
			}
		} else {
			$method = $this->methods[0];
		}

		$configData = array();
		$configFields = $configInfo->configFields;
		// doplnime failed stav, i kdyz ho modu nevyzaduje, protoze VM2 vzdy vytvori order
		if (array_filter($configFields, function($e) {return $e->name=='orderStatusFailed';}) === array()) {
			$configField = new ConfigField();
			$configField->name = 'orderStatusFailed';
			$configField->type = ConfigFieldType::$orderStatus;
			$configFields[]=$configField;
		}
		// doplnime pending stav, i kdyz ho modu nevyzaduje, protoze VM2 vzdy vytvori order, abychom jej mohli ze zacatku neja nastavit
		if (array_filter($configFields, function($e) {return $e->name=='orderStatusPending';}) === array()) {
			$configField = new ConfigField();
			$configField->name = 'orderStatusPending';
			$configField->type = ConfigFieldType::$orderStatus;
			$configFields[]=$configField;
		}
		foreach ($configFields as $configField) {
			if ($configField->type == ConfigFieldType::$subMethodsSelection || $configField->type == ConfigFieldType::$orderStatusMultiple) {
				$configData[$configField->name] = null;
			} else {
				$configData[$configField->name] = $method->{$configField->name};
			}
		}
		$configData['hideMainBinder'] = isset($method->{'hideMainBinder'}) ? $method->{'hideMainBinder'} : false;

		$uniModulConfig = new UniModulConfig();
		$jcfg	= JFactory::getConfig();
		$dbtype = $jcfg->get('dbtype');
		$uniModulConfig->mysql_server = $jcfg->get('host');
		$uniModulConfig->mysql_dbname = $jcfg->get('db');
		$uniModulConfig->mysql_login = $jcfg->get('user');
		$uniModulConfig->mysql_password = $jcfg->get('password');
		$uniModulConfig->uniModulDirUrl = JROUTE::_ (JURI::root () . 'UniModul/');
		$uniModulConfig->funcGetCallbackUrl = array($this, 'getCallbackUrl');
		$uniModulConfig->funcProcessReplyStatus = array($this, 'funcProcessReplyStatus');

		//_DB_PREFIX_ ..

		if ($dbtype != 'mysql' && $dbtype != 'mysqli') user_error('Eshop pouziva jinou nez mysql databazi');

		$uniModulConfig->adapterName = 'VirtueMart2';
		$cfgs = create_initialize_object('ConfigSetting', array('configData'=>$configData, 'uniModulConfig'=>$uniModulConfig));

		return $cfgs;
	}


	protected function getLanguage() {
		$lang = JFactory::getLanguage();
		$locale=strtolower(substr($lang->get('tag'),0,2));
		return $locale;
	}


	function plgVmConfirmedOrder($cart, $order) {
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		try {
			BeginUniErr();

			$html = "";

			if (!class_exists('VirtueMartModelOrders')) {
				require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
			}


			$null = null;
			$orderToPayInfo = $this->getOrderToPayInfo($cart, $order);
			$prePayGWInfo = $this->uniModul->queryPrePayGWInfo($orderToPayInfo);



			// NEJAKE UKLADANI DAT MODULU, sice to nepotrebuju, ale nekde se to ve VM pak pouziva
			/*
			//$this->getPaymentCurrency($method, true);
			//$q  = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
			//$db = JFactory::getDBO();
			//$db->setQuery($q);
			//$currency_code_3        = $db->loadResult();
			//$paymentCurrency        = CurrencyDisplay::getInstance($method->payment_currency);
			//$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
			//$cd                     = CurrencyDisplay::getInstance($cart->pricesCurrency);
			$dbValues['payment_name']                = $this->renderPluginName($method) . '<br />' . $method->payment_info;
			$dbValues['order_number']                = $order['details']['BT']->order_number;
			$dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
			$dbValues['cost_per_transaction']        = $method->cost_per_transaction;
			$dbValues['cost_percent_total']          = $method->cost_percent_total;
			$dbValues['payment_currency']            = $method->payment_currency;
			//$dbValues['payment_currency']            = $currency_code_3;
			$dbValues['payment_order_total']         = $order['details']['BT']->order_total;
			//$dbValues['payment_order_total']         = $totalInPaymentCurrency;
			$dbValues['tax_id']                      = $method->tax_id;
			$this->storePSPluginInternalData($dbValues);
			*/


			// presmerovat na branu
			$redirectAction = $this->uniModul->gatewayOrderRedirectAction($orderToPayInfo);


			// nejaka zmena statusu na pending asi a notifikovat, ale ja to standardne nechci, jen pokud pending je vysledek notifikace nebo reply
			/*
			$modelOrder                 = VmModel::getModel('orders');
			$order['order_status']      = 'P';
			$order['customer_notified'] = 1;
			$order['comments']          = '';
			$modelOrder->updateStatusForOneOrder($order['details']['BT']->virtuemart_order_id, $order, true);
			*/


			// 	2 = don't delete the cart, don't send email and don't redirect
			$cart->_confirmDone = FALSE;
			$cart->_dataValidated = FALSE;
			$cart->setCartIntoSession ();

			if ($redirectAction->orderReplyStatus != null) {   // okamzita odpoved muze byt i zaroven s redirektem - napr. Cetelem
				$frontend_redir = $redirectAction->redirectUrl==null && $redirectAction->redirectForm==null;
				$html='';
				$this->procesReplyStatus($redirectAction->orderReplyStatus, $frontend_redir, $html);
				vRequest::setVar ('html', $html);
			}
			if ($redirectAction->redirectUrl != null) {
				$app = JFactory::getApplication ();
				$uer = ResetUniErr();
				$app->redirect($redirectAction->redirectUrl);
				ResetUniErr($uer);
			} else if ($redirectAction->redirectForm != null) {
				$this->uniModul->formRedirect($redirectAction->redirectForm);
			}
			EndUniErr();
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}


	protected function checkConditions($cart, $method, $cart_prices) {
		try {
			BeginUniErr();
			if ($this->uniModul == null) return EndUniErr();
			if ($this->loopBreaker) return EndUniErr(true);
			// kontrola na zemi, dle std VM2 modulù, (podminky na min a max cenu a menu jsem dal pryc, protoze si tu nejsem jist menou, ale PP to tak ma, takze evt b to slo)
			$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);
			$countries = array();
			if (!empty($method->countries)) {
				if (!is_array ($method->countries)) {
					$countries[0] = $method->countries;
				} else {
					$countries = $method->countries;
				}
			}
			// probably did not gave his BT:ST address
			if (!is_array ($address)) {
				$address = array();
				$address['virtuemart_country_id'] = 0;
			}
			if (!isset($address['virtuemart_country_id'])) {
				$address['virtuemart_country_id'] = 0;
			}
			if (!(in_array ($address['virtuemart_country_id'], $countries) || count ($countries) == 0)) {
				return EndUniErr(false);
			}

			//v $cart_prices neni currency, takze nutno volat $orderToPayInfo, a hlidat inf rekurzi
			$cfg = $this->getConfigData($this->configInfo, $this->uniModul->name, $this->uniModul->subMethod)->configData;
			if ($cfg['hideMainBinder']!=0 && $this->uniModul->subMethod=='') {
				return EndUniErr(false);
			}

			$this->loopBreaker = true;
			$orderToPayInfo = $this->getOrderToPayInfo($cart);
			$this->loopBreaker = false;
			if ($orderToPayInfo->currency==null || $orderToPayInfo->currency=='') return EndUniErr(true); // stava se pri ztrate session, a pak to kolabuje v queryPrePay, kdyz ale vracim false tak to pak neukazuje vyber metodu v kosiku. Lepsi je zavolat tegOrderToPay a ten aby si zjistil cenykosiku, ale to se zacykluje, takze necham takto
			$prePayGWInfo = $this->uniModul->queryPrePayGWInfo($orderToPayInfo);
			return EndUniErr($prePayGWInfo->isPossible);
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}
	var $loopBreaker = false;  //bez toho nekdy dochazi k nekonecnemu rekurzivnimu provolavani

	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		if (!$this->selectedThisByMethodId($cart->virtuemart_paymentmethod_id)) {
			return null; // Another method was selected, do nothing
		}
		try {
			BeginUniErr();
			$ccBrand = JRequest::getVar ('uniadapter_ccBrand', '');
			$session = JFactory::getSession ();
			$session->set('uniadapter_ccBrand',$ccBrand,'vm');
			return EndUniErr($this->OnSelectCheck($cart));
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}


	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		try {
			BeginUniErr();
			if ($this->uniModul == null) return EndUniErr();
			$null = null;
			$orderToPayInfo = $this->getOrderToPayInfo($cart, $null);
			$prePayGWInfo = $this->uniModul->queryPrePayGWInfo($orderToPayInfo);

			if (!$prePayGWInfo->isPossible) return EndUniErr(false);    // to netestuje ale zakaz pro schovani hlavniho binderu, ten otestuje displayListFE

			$html = '';
			if ($prePayGWInfo->selectCsPayBrand === true) {
				$session = JFactory::getSession ();
				$ccBrand = $session->get('uniadapter_ccBrand', '', 'vm');
				$html .= '
				<b>'.$this->uniModul->dictionary->get('ccBrand_title', $this->getLanguage()).'</b><br/>
					<input type="radio" name="uniadapter_ccBrand" value="VISA" '.($ccBrand=='VISA' || $ccBrand==''?"checked":"").'> VISA</input><br/>
					<input type="radio" name="uniadapter_ccBrand" value="MasterCard" '.($ccBrand=='MasterCard'?"checked":"").'> MasterCard</input><br/>
					<input type="radio" name="uniadapter_ccBrand" value="VisaElectron" '.($ccBrand=='VisaElectron'?"checked":"").'> VisaElectron</input><br/>
					<input type="radio" name="uniadapter_ccBrand" value="Maestro" '.($ccBrand=='Maestro'?"checked":"").'> Maestro</input><br/>
				';
			}
			if (isset($prePayGWInfo) && isset($prePayGWInfo->forexMessage)) {
				$html .= '&nbsp;<span style="text-align:left">'.$prePayGWInfo->forexMessage.'</span>';
			}
			if ($html != '') {
				$html = "<p style='margin-left:5ex'>".$html."</p>";
			}
			$html .= "<span style=\"background:url('https://www.platiti.cz/muzo/minilogo.png')\"></span>";

			$htmlTmp = array();
			$ret = $this->displayListFE($cart, $selected, $htmlIn);
			if ($ret) {
				$this->getPluginMethods ($cart->vendorId); // toto je tu jen pro to, aby to nastavilo spravny $method->virtuemart_paymentmethod_id
				$method = $this->methods[0]; // vim ze vzdy prave 1..   (jak by jich vubec mohlo byt vic?)
				if (isset($htmlIn['payment'][$method->virtuemart_paymentmethod_id])) {
					$htmlIn['payment'][$method->virtuemart_paymentmethod_id] .= $html;
				} else {
					$htmlIn[count($htmlIn)-1][0] .= $html;
				}
			}
			return EndUniErr($ret);
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}







	protected function getOrderToPayInfo(&$cart, &$order=null) {
		$orderToPayInfo = new OrderToPayInfo();
		$orderToPayInfo->adapterProperties = array('ShopOrderNumberIsAlpha'=>true);
		if (empty($cart->pricesUnformatted) && empty($cart->cartPrices)) {   // test pro VM2 i pro VM3
			$cart->getCartPrices();   // byla tu poznamka: nekdy nejsou dosazeny nebo jsou neaktualini, tak ohlidat
		}
		$cartPrices = empty($cart->cartPrices) ? $cart->pricesUnformatted : $cart->cartPrices;  // vyber cen mezi VM2 a VM3

		if ($order==null) {
			// pro prePayInfo a nebo pro Express

			$currency = $cart->pricesCurrency;
			$orderToPayInfo->currency = ShopFunctions::getCurrencyByID ($currency, 'currency_code_3');

			if (!empty($cartPrices['billTotal'])) {
				// pri zpracovani expressu to jde vzdy sem
				$amount = $cartPrices['billTotal'];
			} else {
				$amount = $cartPrices['salesPrice'];  // toto je ale bez dopravy, v teto chvily by to nemelo vadit (? metody, ktere se zobrazuji na zaklade vyse castky?)
			}
			$orderToPayInfo->amount = $amount;

			$product_names = array();
			foreach ($cart->products as $key => $product) {
				 $product_names[] = substr(strip_tags($product->product_name), 0, 30);
			}
			$description = implode(", ", $product_names);

			$customerData = new CustomerData();
			/*
			$customerData->first_name = $cart->BT['first_name'];
			$customerData->last_name = $cart->BT['last_name'];
			$customerData->email = $cart->BT['email'];
			$customerData->street = $cart->BT['address_1'] . " ". $cart->BT['address_2'];
			$customerData->city = $cart->BT['city'];
			$customerData->post_code = $cart->BT['zip'];
			$customerData->country = ShopFunctions::getCountryByID($cart->BT['virtuemart_country_id']);
			$customerData->phone = $cart->BT['phone_1'];
			*/
			$orderToPayInfo->customerData = $customerData;
		} else {
			$bt = $order['details']['BT'];
			$orderToPayInfo->shopPairingInfo = $bt->order_number;
			$orderToPayInfo->shopOrderNumber = $bt->order_number;  //The order numbers look now like this c9b2051. The first 4 chars are random. then comes a zero and after that your incrementing serial.
			$currency = $bt->user_currency_id;
			$orderToPayInfo->currency = ShopFunctions::getCurrencyByID ($currency, 'currency_code_3');
			$amount = $bt->order_total;
			if (!class_exists('CurrencyDisplay')) require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'currencydisplay.php');
			$paymentCurrency = CurrencyDisplay::getInstance($currency);
			$amountConverted = method_exists ($paymentCurrency, 'roundForDisplay')
				? $paymentCurrency->roundForDisplay($amount)
				: $paymentCurrency->convertCurrencyTo($currency, $amount, false);
			$orderToPayInfo->amount = $amountConverted;

			$product_names = array();
			$cartItems = array();
			foreach ($order['items'] as $key => $product) {
				$product_names[] = mb_substr(strip_tags($product->order_item_name), 0, 30, 'UTF-8');

				$cartItem = new UniCartItem();
				$cartItem->type = UniCartItemType::commodity;
				$cartItem->name = $product->order_item_name;
				$cartItem->quantity = $product->product_quantity;
				BeginUniErr(E_UNIERR_DEFAULT & ~E_NOTICE);
				$cartItem->unitPrice = $paymentCurrency->convertCurrencyTo($currency, $product->product_final_price, false);
				EndUniErr();
				if (isset($product->product_tax_id)) {
					$tax = ShopFunctions::getTaxByID($product->product_tax_id);
					$cartItem->taxRate = round($tax['calc_value'],1);
				} else {
					if (isset($cartPrices[$product->virtuemart_product_id])) {
						$cp = $cartPrices[$product->virtuemart_product_id];
					} else if (isset($cartPrices[$key])) {
						$cp = $cartPrices[$key];
					} else {
						$cp = round(100*$product->product_tax/$product->product_priceWithoutTax);
					}
					if (!empty($cp['VatTax'])) {
						$cpt = array_values($cp['VatTax']);
						$cartItem->taxRate = floatval($cpt[0][1]);
					} else if (!empty($cp['Tax'])) {
						$cpt = array_values($cp['Tax']);
						$cartItem->taxRate = floatval($cpt[0][1]);
					} else {
						$cartItem->taxRate = $cp;
					}
				}
				$cartItems[] = $cartItem;
			}
			$description = implode(", ", $product_names);
			$orderToPayInfo->description = $description;

			$cartItem = new UniCartItem();
			$cartItem->type = UniCartItemType::delivery;
			$cartItem->name = "Shipping / Doprava";
			$cartItem->quantity = 1;
			BeginUniErr(E_UNIERR_DEFAULT & ~E_NOTICE);
			$cartItem->unitPrice = $paymentCurrency->convertCurrencyTo($currency, $bt->order_shipment + $bt->order_shipment_tax, false);
			EndUniErr();
			$cartItem->taxRate = $bt->order_shipment == 0 ? 0 : round(100 * ($bt->order_shipment_tax / $bt->order_shipment), 0);
			$cartItems[] = $cartItem;


			// slevy
			foreach ($order['calc_rules'] as $crule) {
				if ($crule->calc_kind == 'DBTaxRulesBill') {
					$cartItem = new UniCartItem();
					$cartItem->type = UniCartItemType::discount;
					$cartItem->name = $crule->calc_rule_name;
					$cartItem->quantity = 1;
					$cartItem->unitPrice = $paymentCurrency->convertCurrencyTo($currency, $crule->calc_amount, false);
					// DPH nevim, pokud bude potreba, tak asi rozpocitat na pasma...
					$cartItems[] = $cartItem;
				}
			}

			$orderToPayInfo->cartItems = $cartItems;


			// kontrolni soucet
			$chksum = array_reduce($cartItems, function ($s, $ci) {return $s + $ci->unitPrice * $ci->quantity;}, 0);
			if (abs($chksum - $orderToPayInfo->amount) >= 0.01) {
				$this->uniModul->logger->writeLog("ADAPTER: Nesouhlasi castky v polozkach kosiku. Placena castka " . $orderToPayInfo->amount . ", soucet polozek je " . $chksum . " Polozky kosiku: " . print_r($cartItems, true));
			}


			$customerData = new CustomerData();
			$customerData->first_name = $bt->first_name;
			$customerData->last_name = $bt->last_name;
			$customerData->email = $bt->email;
			$customerData->street = $bt->address_1 . " ". $bt->address_2;
			$customerData->city = $bt->city;
			$customerData->post_code = $bt->zip;
			$customerData->country = ShopFunctions::getCountryByID($bt->virtuemart_country_id, 'country_2_code');
			$customerData->phone = $bt->phone_1;
			if(!$customerData->phone) {
				if(isset($bt->phone_2))
					$customerData->phone = $bt->phone_2;
			}
			$customerData->identifier = $bt->virtuemart_user_id !=0 ? $bt->virtuemart_user_id : null;  // neregistrovany uzivatel ma id = 0
			$orderToPayInfo->customerData = $customerData;

		}
		$orderToPayInfo->notifyUrl = JROUTE::_ (JURI::root () . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component&lang='.$this->getLanguage().'&unimodul='.$this->uniModul->name);
        $orderToPayInfo->replyUrl = JROUTE::_ (JURI::root () . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&lang='.$this->getLanguage().'&unimodul='.$this->uniModul->name);
		$orderToPayInfo->uniModulDirUrl = JROUTE::_ (JURI::root () . 'UniModul/');

		$orderToPayInfo->language = $this->getLanguage();


		// TODO: docasne reseni, pak pouzit callback pres fci pro neexistujici property
		$currencies = array("CZK", "EUR", "GBP", "USD", "BGN", "CAD", "DKK", "HRK", "HUF", "CHF", "LTL", "NOK", "PLN", "RON", "RUB", "SEK", "TRY");
		$paymentCurrency = CurrencyDisplay::getInstance(ShopFunctions::getCurrencyIDByName($orderToPayInfo->currency));
		$currencyRates = array();
		foreach($currencies as $cur) {
			BeginUniErr(E_UNIERR_DEFAULT & ~E_NOTICE);
			$currencyRates[$cur] = $paymentCurrency->convertCurrencyTo(ShopFunctions::getCurrencyIDByName($cur), 100, false);
			EndUniErr();
		}
		$orderToPayInfo->currencyRates = $currencyRates;

		$session = JFactory::getSession ();
		$ccBrand = $session->get ('uniadapter_ccBrand', '', 'vm');
		$orderToPayInfo->ccBrand = $ccBrand;

		$orderToPayInfo->uniAdapterData = array('session_id' => $session->getId());

		return $orderToPayInfo;
	}


	public function plgVmOnPaymentNotification() {
		if (JRequest::getVar ('_callbackName',null) != null) {
			return $this->processCallback();
		}
		if (JRequest::getVar ('unimodul',null) != $this->uniModul->name) {
			return NULL;
		}
		try {
			BeginUniErr();
			$orderReplyStatus = $this->uniModul->gatewayReceiveNotification();
			$html='';
			$this->procesReplyStatus($orderReplyStatus, false, $html);
			ResetUniErr();
			exit; //bez exitu to vypise nejake HTML, coz pri notfikaci muze mnoha systemum vadit
			return EndUniErr(TRUE);  // jaky je rozdil kdyby tu bylo FALSE?
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}


	function plgVmOnPaymentResponseReceived(&$html) {
		if ($this->uniModul == null || JRequest::getVar ('unimodul',null) != $this->uniModul->name || $this->uniModul->subMethod!='') {
			return NULL;
		}
		try {
			BeginUniErr();
			$orderReplyStatus = $this->uniModul->gatewayReceiveReply($this->getLanguage());
			$this->procesReplyStatus($orderReplyStatus, true, $html);
			return EndUniErr(TRUE);  // jaky je rozdil kdyby tu bylo FALSE?
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}


	function procesReplyStatus($orderReplyStatus, $frontend_redir, &$html) {
		$cfg = $this->getConfigData($this->configInfo, $this->uniModul->name, $this->uniModul->subMethod)->configData;
		switch ($orderReplyStatus->orderStatus) {
			case OrderStatus::$successful:
				$newState = $cfg['orderStatusSuccessfull'];
				$guiOk = true;
				break;
			case OrderStatus::$pending:
				$newState = $cfg['orderStatusPending'];
				$guiOk = true;
				break;
			case OrderStatus::$failedRetriable;  //vzdy se vytvari novy order, takze zadne retry
			case OrderStatus::$failedFinal:
				$newState = $cfg['orderStatusFailed'];
				$guiOk = false;
				break;
			case OrderStatus::$invalidReply;
				$newState = null;
				$guiOk = false;
				break;
			default:
				user_error('neznamy status: '.$orderReplyStatus->orderStatus);
		}
		BeginSynchronized();

		$ordernumber = $orderReplyStatus->shopPairingInfo;
		if (!empty($orderReplyStatus->successHtml)) {
			$orderReplyStatus->uniAdapterData['successHtml'] = $orderReplyStatus->successHtml;
			$transactionRecord = $this->uniModul->getOrderTransactionRecordFromDbUnique($orderReplyStatus->gwOrderNumber);
			$this->uniModul->updateUniAdapterDataInDb($transactionRecord->transactionPK, $orderReplyStatus->uniAdapterData);
		}



		if ($newState != null) {

			if (!class_exists ('VirtueMartModelOrders')) {
				require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
			}
			$orderModel = new VirtueMartModelOrders();
			$virtuemart_order_id = $orderModel->getOrderIdByOrderNumber($ordernumber);
			if (!$virtuemart_order_id) {
				$html = "nenalezeno";
				return NULL;
			}
			$modelOrder = VmModel::getModel('orders');
			$order_act = $modelOrder->getOrder($virtuemart_order_id);

			$order = array();
			$transientStates = array($cfg['orderStatusPending'], $cfg['orderStatusFailed'], 'P');  //'P' abysme mohli notifikovat novou pending objednavku
			if (($order_act['details']['BT']->order_status!=$newState || $newState == 'P') && in_array($order_act['details']['BT']->order_status, $transientStates)) {
				$order['customer_notified'] = 1;
				$order['order_status'] = $newState;
				$order['virtuemart_order_id'] = $virtuemart_order_id;
				$date = JFactory::getDate ();

				$comment = '';
				if ($orderReplyStatus->forexNote !== null) {
					$comment .= "<br/>".$this->uniModul->dictionary->get('forexNoteLabel', $this->getLanguage()). ': ' . $orderReplyStatus->forexNote;
				}

				$order['comments'] = $comment;
				$this->uniModul->logger->writeLog("ADAPTER: Updating shop order number:" . $ordernumber . ", id:" . $virtuemart_order_id.", old order state ".$order_act['details']['BT']->order_status.", new order state ".$newState);
				BeginUniErr(E_UNIERR_DEFAULT & ~E_STRICT & ~E_NOTICE & ~E_WARNING & ~E_DEPRECATED);
				$modelOrder->updateStatusForOneOrder ($virtuemart_order_id, $order, TRUE);
				EndUniErr();
			} else {
				$this->uniModul->logger->writeLog("ADAPTER: Not updating shop order number " . $ordernumber . ", id:" . $virtuemart_order_id.", old order state ".$order_act['details']['BT']->order_status.", new order state ".$newState);
			}
		}

		if ($guiOk) {
			$session = JFactory::getSession();
			$session_id = isset($orderReplyStatus->uniAdapterData['session_id']) ? $orderReplyStatus->uniAdapterData['session_id'] : $orderReplyStatus->uniAdapterData/*zpetna kompatibilita se starymi adapterdata*/;
			if ($session_id != $session->getId()) {
				$this->emptyCart($session_id, $ordernumber);
			} else {
				$cart = VirtueMartCart::getCart ();
				$cart->emptyCart ();
			}

		}
		EndSynchronized();

		if ($frontend_redir) {
			if ($guiOk) {
				if (method_exists('VmConfig','loadJLang')) {
					VmConfig::loadJLang('com_virtuemart_orders', true);
				} else {
					$lang = JFactory::getLanguage();
					$lang->load('com_virtuemart', JPATH_ADMINISTRATOR);
				}
				//$html = JText::_ ('COM_VIRTUEMART_PAYMENT_TRANSACTION_SUCCESS');

				$viewData = array(
					'order_number' =>$order_act['details']['BT']->order_number,
					'order_pass' =>$order_act['details']['BT']->order_pass,
				);

				if (method_exists('vmPSPlugin','getAmountInCurrency')) {
					$totalInPaymentCurrency = vmPSPlugin::getAmountInCurrency($order_act['details']['BT']->order_total, $order_act['details']['BT']->user_currency_id);
					$viewData['displayTotalInPaymentCurrency'] = $totalInPaymentCurrency['display'];
				} else {
					$viewData['displayTotalInPaymentCurrency'] = '';
				}

				if (!empty($orderReplyStatus->successHtml)) {
					$viewData['successHtml'] = $orderReplyStatus->successHtml;
				} else {
					$viewData['successHtml'] = '';
				}

				ob_start ();
				include(dirname(__FILE__)."/post_payment.php");
				$html = ob_get_clean ();
			} else {
				$app = JFactory::getApplication ();
				$carturl = JROUTE::_ ('index.php?option=com_virtuemart&view=cart');

				$uer = ResetUniErr();
				$app->redirect($carturl, JText::_ ('VMPAYMENT_UNIADAPTER_GATEWAY_FAILED') . '<br/>' . $orderReplyStatus->resultText,'error');
				ResetUniErr($uer);
			}
		}
	}

	public function funcProcessReplyStatus($orderReplyStatus) {
		$html = null;
		$this->procesReplyStatus($orderReplyStatus, false, $html);
	}

	function plgVmOnStoreInstallPaymentPluginTable ($jplugin_id) {
		$this->onStoreInstallPluginTable($jplugin_id);
	}

	public function onStoreInstallPluginTable($jplugin_id, $name = FALSE) {
		try {
			BeginUniErr();
			$sql = file_get_contents (dirname(__FILE__) . "/UniModul.sql");
			$db = JFactory::getDBO();
			$db->setQuery($sql);
			if (!$db->execute()) {
				user_error("Chyba pri vytvareni sql tabulky unimodulu: " . $db->stderr(TRUE));
			}
			return EndUniErr(parent::onStoreInstallPluginTable ($jplugin_id, $name));
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}

	public function getVmPluginCreateTableSQL() {
		try {
			BeginUniErr();
			return EndUniErr($this->createTableSQL('Payment UniAdapter Table'));
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}

	function getTableSQLFields() {
		try {
			BeginUniErr();
			$SQLfields = array(
				'id'                          => 'int(1) UNSIGNED NOT NULL AUTO_INCREMENT',
				'virtuemart_order_id'         => 'int(1) UNSIGNED',
				'order_number'                => 'char(64)',
				'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
				'payment_name'                => 'varchar(5000)',
				'payment_order_total'         => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
				'payment_currency'            => 'char(3)',
				'cost_per_transaction'        => 'decimal(10,2)',
				'cost_percent_total'          => 'decimal(10,2)',
				'tax_id'                      => 'smallint(1)'
			);
			return EndUniErr($SQLfields);
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}


	function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id) {
		if (!$this->selectedThisByMethodId($virtuemart_payment_id)) {
			return NULL; // Another method was selected, do nothing
		}
		try {
			BeginUniErr();
			$paymentTable = $this->getDataByOrderId ($virtuemart_order_id);
			$modelOrder = VmModel::getModel('orders');
			$order = $modelOrder->getOrder($virtuemart_order_id);
			$orderNumber = $order['details']['BT']->order_number;

			if ($this->uniModul == null) {
				user_error('V objednavce v administraci nullovy UniModul');
				return;
			}
			$transactionRecord = $this->uniModul->getOrderTransactionRecordFromDbLast($orderNumber);

			$html = '<table class="adminlist">' . "\n";
			$html .= $this->getHtmlHeaderBE();
			$uniName = $this->uniModul->dictionary->get('payment_method_name', $this->getLanguage());
			if ($transactionRecord != null && !empty($transactionRecord->uniAdapterData['successHtml'])) {
				$uniName .= "<p/>" . $transactionRecord->uniAdapterData['successHtml'];
			}
			$html .= $this->getHtmlRowBE('UNIADAPTER_PAYMENT_NAME', $uniName);
			if ($transactionRecord != null) {
				$html .= $this->getHtmlRowBE('UNIADAPTER_GATEWAY_ORDER_NUMBER', $transactionRecord->gwOrderNumber);
				if ($transactionRecord->forexNote) {
					$html .= $this->getHtmlRowBE('UNIADAPTER_GATEWAY_FOREX', $transactionRecord->forexNote);
				}
			}
			$html .= '</table>' . "\n";
			return EndUniErr($html);
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}

	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		if (!($this->selectedThisByMethodId($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		try {
			BeginUniErr();
			$payment_name = $this->uniModul->dictionary->get('payment_method_name', $this->getLanguage());

			$modelOrder = VmModel::getModel('orders');
			$order = $modelOrder->getOrder($virtuemart_order_id);
			$orderNumber = $order['details']['BT']->order_number;
			$transactionRecord = $this->uniModul->getOrderTransactionRecordFromDbLast($orderNumber);
			if ($transactionRecord != null && !empty($transactionRecord->uniAdapterData['successHtml'])) {
				$payment_name .= "<p/>" . $transactionRecord->uniAdapterData['successHtml'];
			}
			EndUniErr();
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}

////////////////////////////////////


	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}

	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		try {
			BeginUniErr();

			// modul umi vsechny meny, ale VM chce jen jednu konkretni, tak vratime tu co je zrovna zvolena
			$cart = VirtueMartCart::getCart();
			//$currency = $cart->paymentCurrency != null ? $cart->paymentCurrency : $cart->pricesCurrency;
			$currency = $cart->pricesCurrency;
			$method->payment_currency = $currency;
			$this->getPaymentCurrency($method); // mozna uz neni nutne

			$paymentCurrencyId = $method->payment_currency;
			return EndUniErr();
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}

	function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter) {
		return $this->onCheckAutomaticSelected($cart, $cart_prices, $paymentCounter);
	}
	function plgVmonShowOrderPrintPayment($order_number, $method_id) {
		return $this->onShowOrderPrint($order_number, $method_id);
	}

	function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
		return $this->declarePluginParams('payment', $name, $id, $data);
	}

	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}

	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
		return $this->setOnTablePluginParams($name, $id, $table);
	}


	function plgVmOnProductDisplayPayment($product, &$productDisplay) {
		if ($this->uniModul == null) return false;
		if ($this->uniModul->subMethod != null) {  // jen pro hlavni modul
			return false;
		}
		$cart = VirtueMartCart::getCart();
		$vendorId = $cart->vendorId;
		if ($this->getPluginMethods($vendorId) === 0) {  // jen pokud je instalovana metoda
			return FALSE;
		}
		try {
			BeginUniErr();
			$product_price = $product->prices['salesPrice'];
			if ($product_price == null) { // cena neni znama - typicky na dotaz -> nezobrazovat
				return EndUniErr(false);
			}
			$product_currency = ShopFunctions::getCurrencyByID (isset($product->prices['product_currency']) ? $product->prices['product_currency'] : $product->product_currency, 'currency_code_3');
			$shopBaseUrl = JURI::root();
			$embedHtml = $this->uniModul->ProductGetInstallmentEmbedHtml($shopBaseUrl, $product_currency, $product_price);
			if ($embedHtml == null) {
				return EndUniErr(false);
			}
			$productDisplay[] = "<p>".$embedHtml."</p>";
			return EndUniErr(TRUE);
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}

	public function processCallback() {
		if (JRequest::getVar ('_unimodul',null) != $this->uniModul->name) {
			return NULL;
		}
		try {
			BeginUniErr();

			parse_str($_SERVER['QUERY_STRING'], $cbArgs);
			$this->uniModul->processCallbackRequest($_GET['_callbackName'], $cbArgs);

			ResetUniErr();	exit; //bez exitu to vypise nejake HTML, coz pri notfikaci muze mnoha systemum vadit
			return EndUniErr(TRUE);  // jaky je rozdil kdyby tu bylo FALSE?
		} catch (Exception $ex) {
			ExceptionUniErr($ex);
		}
	}

	function getCallbackUrl($callbackName, $arguments) {
		return JROUTE::_ (JURI::root () . "index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&lang=".$this->getLanguage()."&tmpl=component&_unimodul=".$this->uniModul->name."&_callbackName=".urlencode($callbackName)."&".http_build_query($arguments));
	}

}

// No closing tag



